#ifndef __MYPRAGMA_H__
#define __MYPRAGMA_H__
/**
 * HC pragma support from ROSE
 *
 * author yy8
 * yy8@rice.edu
 *
 */

#include "rose.h"
#include <iostream>

using namespace SageInterface;
using namespace SageBuilder;

enum mypragma_enum {
  pragma_xev_at_num,
  pragma_xev_at_name
};
/*
hcc_pragma = ' #pragma' 'xev ' 'at'  assignment_expression assignment_expression
*/
class MY_PragmaAttribute: public AstAttribute
{
  public:
    SgNode * node;

    enum mypragma_enum pragma_type;
    SgExpression* number;
     MY_PragmaAttribute (SgNode* n , mypragma_enum p_type,SgExpression* num): node(n), pragma_type(p_type),number(num){ }

    virtual std::string toString ()
    {
      std::string result;
      result =number->unparseToString();
      return result;
    }
};
extern AstAttribute* parse_MY_Pragma(SgPragmaDeclaration* pragmaDecl);

#endif /* __HCPRAGMA_H__ */
